! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 23:09 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module BranchingRatios_Inert 
 
Use Control 
Use Couplings_Inert 
Use Model_Data_Inert 
Use LoopCouplings_Inert 
Use Fu3Decays_Inert 
Use Fe3Decays_Inert 
Use Fd3Decays_Inert 
Use SUSYDecays_Inert 
 
Contains 
 
Subroutine CalculateBR(CTBD,fac3,epsI,deltaM,kont,MA0,MA02,MFd,MFd2,MFe,              & 
& MFe2,MFu,MFu2,MG0,MG02,MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,              & 
& ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,ZW,ZZ,betaH,v,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,            & 
& Ye,Yd,Yu,mHd2,mHu2,gPFu,gTFu,BRFu,gPFe,gTFe,BRFe,gPFd,gTFd,BRFd,gPhh,gThh,             & 
& BRhh,gPH0,gTH0,BRH0,gPA0,gTA0,BRA0,gPHp,gTHp,BRHp)

Real(dp), Intent(in) :: epsI, deltaM, fac3 
Integer, Intent(inout) :: kont 
Logical, Intent(in) :: CTBD 
Real(dp),Intent(in) :: g1,g2,g3,mHd2,mHu2

Complex(dp),Intent(in) :: Lam5,Lam1,Lam4,Lam3,Lam2,Ye(3,3),Yd(3,3),Yu(3,3)

Real(dp),Intent(in) :: MA0,MA02,MFd(3),MFd2(3),MFe(3),MFe2(3),MFu(3),MFu2(3),MG0,MG02,MH0,MH02,              & 
& Mhh,Mhh2,MHp(2),MHp2(2),MVWp,MVWp2,MVZ,MVZ2,TW,ZP(2,2),ZZ(2,2),betaH

Complex(dp),Intent(in) :: ZDL(3,3),ZDR(3,3),ZEL(3,3),ZER(3,3),ZUL(3,3),ZUR(3,3),ZW(2,2)

Real(dp),Intent(in) :: v

Real(dp),Intent(inout) :: gPFu(3,147),gTFu(3),BRFu(3,147),gPFe(3,144),gTFe(3),BRFe(3,144),gPFd(3,147),          & 
& gTFd(3),BRFd(3,147),gPhh(1,39),gThh,BRhh(1,39),gPH0(1,5),gTH0,BRH0(1,5),               & 
& gPA0(1,5),gTA0,BRA0(1,5),gPHp(2,26),gTHp(2),BRHp(2,26)

Complex(dp) :: cplHiggsPP,cplHiggsGG,cplPseudoHiggsPP,cplPseudoHiggsGG,cplHiggsZZvirt,               & 
& cplHiggsWWvirt

Real(dp) :: gTG0 
Real(dp) :: gFuFucFdFd(3,3,3,3),gFuFdcFeFv(3,3,3,3),gFuFucFeFe(3,3,3,3),gFuFucFuFu(3,3,3,3),      & 
& gFuFucFvFv(3,3,3,3),gFeFecFdFd(3,3,3,3),gFeFecFeFe(3,3,3,3),gFeFecFuFu(3,3,3,3),       & 
& gFeFecFvFv(3,3,3,3),gFeFvcFuFd(3,3,3,3),gFdFdcFdFd(3,3,3,3),gFdFdcFeFe(3,3,3,3),       & 
& gFdFdcFuFu(3,3,3,3),gFdFdcFvFv(3,3,3,3),gFdFucFvFe(3,3,3,3)

Complex(dp) :: coup 
Real(dp) :: vev 
Real(dp) :: gTVZ,gTVWp

Iname = Iname + 1 
NameOfUnit(Iname) = 'CalculateBR'
 
Write(*,*) "Calculating branching ratios and decay widths" 
gTVWp = gamW 
gTVZ = gamZ 
gPFu = 0._dp 
gTFu = 0._dp 
BRFu = 0._dp 
If (.Not.CTBD) Then 
Call FuTwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPFu(:,1:12)    & 
& ,gTFu,BRFu(:,1:12))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFu).Lt.MaxVal(fac3*Abs(MFu))) Then 
Call FuThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,gFuFucFvFv,epsI,           & 
& deltaM,.False.,gTFu,gPFu(:,13:147),BRFu(:,13:147))

Else 
Call FuThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,gFuFucFvFv,epsI,           & 
& deltaM,.True.,gTFu,gPFu(:,13:147),BRFu(:,13:147))

End If 
 
End If 
Else 
Call FuThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFuFucFdFd,gFuFdcFeFv,gFuFucFeFe,gFuFucFuFu,gFuFucFvFv,epsI,           & 
& deltaM,.False.,gTFu,gPFu(:,13:147),BRFu(:,13:147))

End If 
Do i1=1,3
gTFu(i1) =Sum(gPFu(i1,:)) 
If (gTFu(i1).Gt.0._dp) BRFu(i1,: ) =gPFu(i1,:)/gTFu(i1) 
End Do 
 

gPFe = 0._dp 
gTFe = 0._dp 
BRFe = 0._dp 
If (.Not.CTBD) Then 
Call FeTwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPFe(:,1:9)     & 
& ,gTFe,BRFe(:,1:9))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFe).Lt.MaxVal(fac3*Abs(MFe))) Then 
Call FeThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,gFeFvcFuFd,epsI,           & 
& deltaM,.False.,gTFe,gPFe(:,10:144),BRFe(:,10:144))

Else 
Call FeThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,gFeFvcFuFd,epsI,           & 
& deltaM,.True.,gTFe,gPFe(:,10:144),BRFe(:,10:144))

End If 
 
End If 
Else 
Call FeThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFeFecFdFd,gFeFecFeFe,gFeFecFuFu,gFeFecFvFv,gFeFvcFuFd,epsI,           & 
& deltaM,.False.,gTFe,gPFe(:,10:144),BRFe(:,10:144))

End If 
Do i1=1,3
gTFe(i1) =Sum(gPFe(i1,:)) 
If (gTFe(i1).Gt.0._dp) BRFe(i1,: ) =gPFe(i1,:)/gTFe(i1) 
End Do 
 

gPFd = 0._dp 
gTFd = 0._dp 
BRFd = 0._dp 
If (.Not.CTBD) Then 
Call FdTwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPFd(:,1:12)    & 
& ,gTFd,BRFd(:,1:12))

If (Enable3BDecaysF) Then 
If (MaxVal(gTFd).Lt.MaxVal(fac3*Abs(MFd))) Then 
Call FdThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,gFdFucFvFe,epsI,           & 
& deltaM,.False.,gTFd,gPFd(:,13:147),BRFd(:,13:147))

Else 
Call FdThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,gFdFucFvFe,epsI,           & 
& deltaM,.True.,gTFd,gPFd(:,13:147),BRFd(:,13:147))

End If 
 
End If 
Else 
Call FdThreeBodyDecay(-1,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,MH0,            & 
& MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,ZUR,              & 
& ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gThh,               & 
& gTHp,gTVWp,gTVZ,gFdFdcFdFd,gFdFdcFeFe,gFdFdcFuFu,gFdFdcFvFv,gFdFucFvFe,epsI,           & 
& deltaM,.False.,gTFd,gPFd(:,13:147),BRFd(:,13:147))

End If 
Do i1=1,3
gTFd(i1) =Sum(gPFd(i1,:)) 
If (gTFd(i1).Gt.0._dp) BRFd(i1,: ) =gPFd(i1,:)/gTFd(i1) 
End Do 
 

gPhh = 0._dp 
gThh = 0._dp 
BRhh = 0._dp 
Call hhTwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPhh,           & 
& gThh,BRhh)

gPH0 = 0._dp 
gTH0 = 0._dp 
BRH0 = 0._dp 
Call H0TwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPH0,           & 
& gTH0,BRH0)

gPA0 = 0._dp 
gTA0 = 0._dp 
BRA0 = 0._dp 
Call A0TwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPA0,           & 
& gTA0,BRA0)

gPHp = 0._dp 
gTHp = 0._dp 
BRHp = 0._dp 
Call HpTwoBodyDecay(-1,DeltaM,MA0,MA02,MFd,MFd2,MFe,MFe2,MFu,MFu2,MG0,MG02,           & 
& MH0,MH02,Mhh,Mhh2,MHp,MHp2,MVWp,MVWp2,MVZ,MVZ2,TW,ZDL,ZDR,ZEL,ZER,ZP,ZUL,              & 
& ZUR,ZW,ZZ,betaH,g1,g2,g3,Lam5,Lam1,Lam4,Lam3,Lam2,Ye,Yd,Yu,mHd2,mHu2,v,gPHp,           & 
& gTHp,BRHp)

! Set Goldstone Widhts 
gTHp(1)=gTVWp


Iname = Iname - 1 
 
End Subroutine CalculateBR 
End Module BranchingRatios_Inert 
 